Attribute VB_Name = "modDeclarations"
Option Explicit

'API:
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

'TYPES:
Public Type aBRICK
    X           As Long
    Y           As Long
    W           As Long
    H           As Long
    Style       As BrickStyleConstants
    Bonus       As BonusStyleConstants
    Frame       As Long
    ms          As Single
End Type

Public Type aBALL
    X           As Long
    Y           As Long
    D           As Long '   W = H -> D
    W           As Long '    image width (sometimes not equal to D)
    H           As Long '    image height (sometimes not equal to D)
    xSpeed      As Long
    ySpeed      As Long
    Style       As BallStyleConstants
    Frame       As Long '   some balls has animations
    ms          As Single
    Holding     As Boolean
End Type

Public Type aPADDLE
    X           As Long
    Y           As Long
    W           As Long
    sName       As String * 15
    Lifes       As Long
    Score       As Long
    Style()     As BonusStyleConstants ' may have more than one bonus applayed
    Frame()     As Long
    ms()        As Single
    bCount      As Long '    bonus applayed count
End Type

Public Type aBONUS
    X           As Long
    Y           As Long
    D           As Long
    Visible     As Boolean
    Style       As BonusStyleConstants
End Type

Public Type aHIGHSCORE
    sName       As String * 15
    sScore      As Long
End Type

Public Type aBullet 'when gun-paddle fires
    X           As Long
    Y           As Long
    Level       As Long
End Type

Public Type GameStatus
    Playing     As Boolean
    Paused      As Boolean
    Level       As Long
End Type

Public Type PlayBoard 'Rect
    X           As Long
    Y           As Long
    W           As Long
    H           As Long
End Type

Public Type LEVELFORMAT
    lBricks     As Long
    lMetal      As Long
    lX()        As Long
    lY()        As Long
    lW()        As Long
    lH()        As Long
    lType()     As Long
End Type

'ENUMS:

Public Enum BallStyleConstants
    BALL_NORMAL = 0         '   normal ball
    BALL_FAST = 1           '   small fast ball
    BALL_SLOW = 2           '   big slow ball
    BALL_BLACK = 3          '   blank ball (can't break any brick)
    BALL_RED = 4            '   fire ball (breaks any brick)
    BALL_CASPER = 5         '   ghost ball (goes trought metal bricks)
    BALL_BOMB = 6           '   when hit brick also destryes all bricks in its radius
End Enum

Public Enum BrickStyleConstants
    BRICK_NORMAL = 0        '   brings 2 points (2p)
    BRICK_SOFT = 1          '   1p, ball don't bounce when hit it
    BRICK_METAL = 2         '   5p, only fire ball (or super gun) can destroy it
    BRICK_BLUE = 3          '   2p, turns into normal when hitted
    BRICK_CASPER = 4        '   4p, can disappear :)
    BRICK_RED = 5           '   2p, turns into blue when hitted
    BRICK_BOMB = 6          '   1p, destroys bricks in its radius
End Enum

Public Enum BonusStyleConstants
    BONUS_NONE = 0          '   noraml paddle
    BONUS_EXPANDPADDLE = 1  '   expands paddle's width
    BONUS_SHRINKPADDLE = 2  '   shrinks paddle's width
    BONUS_KILLPADDLE = 3    '   kills paddle (player loses 1 life)
    BONUS_LIFE = 4          '   an extra life
    BONUS_SOFT = 5          '   turns all bricks into soft ones
    BONUS_GUN = 6           '   a gun-paddle (1st level)
    BONUS_SUPERGUN = 7      '   a gun-paddle (2nd level)
    BONUS_CATCH = 8         '   ball is catched when hits paddle
    BONUS_ENDLEVEL = 9      '   ends level
    BONUS_FASTBALL = 10     '   (small) fast ball
    BONUS_SLOWBALL = 11     '   (big) slow ball
    BONUS_FIREBALL = 12     '   fire ball
    BONUS_BLACKBALL = 13    '   blank ball
    BONUS_CASPERBALL = 14   '   'ghost' ball
    BONUS_BOMBBALL = 15     '   bomb ball
End Enum

'DIMS:
Public HighScores(1 To 10)      As aHIGHSCORE
Public Game                     As GameStatus
Public Player                   As aPADDLE
Public Bullet()                 As aBALL
Public Bonus()                  As aBONUS
Public Brick()                  As aBRICK
Public Bricks                   As Long
Public MetalBricks              As Long     ' level end when all bricks are destroyed or only metal bricks are left
Public BricksLeft               As Long
Public Ball()                   As aBALL
Public Balls                    As Long
Public BackBuffer               As pcMemDC  ' window background
Public PlayField                As pcMemDC
Public Paddle                   As pcMemDC  ' holds paddle images
Public cBall                    As pcMemDC  ' holds ball images
Public cBricks                  As pcMemDC  ' holds bricks images
Public Board                    As PlayBoard
