Attribute VB_Name = "modGame"
Option Explicit

Private PreviousTime    As Single
Public Timelapse        As Single
'

Public Sub Quit()
    On Error Resume Next
    Set BackBuffer = Nothing
    Set PlayField = Nothing
    Set Paddle = Nothing
    Set cBall = Nothing
    Set cBricks = Nothing
    Unload frmMain
    End
End Sub
Public Sub NewGame()
    On Error Resume Next
    
    'setup player
    Player.bCount = 1
    ReDim Player.Frame(Player.bCount) As Long
    ReDim Player.ms(Player.bCount) As Single
    ReDim Player.Style(Player.bCount) As BonusStyleConstants
    Player.Lifes = 3
    Player.Frame(1) = 0
    Player.ms(1) = 0
    Player.Score = 0
    Player.Style(1) = BONUS_NONE
    'Player.Style(2) = BONUS_GUN
    Player.W = 100
    Player.X = Board.W / 2 - 50
    Player.Y = BackBuffer.Height - 30
    
    'setup ball
    Balls = 1
    ReDim Ball(1 To Balls) As aBALL
    Ball(1).X = 50 'when Holding = True then Ball.X = Player.X + Ball.X
    Ball(1).Y = Player.Y - 15 - Board.Y
    Ball(1).D = 15
    Ball(1).H = 15
    Ball(1).W = 15
    Ball(1).Frame = 0
    Ball(1).ms = 0
    Ball(1).Style = BALL_NORMAL
    Ball(1).ySpeed = -3
    Ball(1).Holding = True
    
    'load first level
    Call LoadLevel(1)
    
    'game setup
    Game.Level = 1
    Game.Paused = False
    Game.Playing = False
    
    DoDraw
End Sub
Public Sub GameLoop()
    On Error Resume Next
    
    Dim lTmrCounter     As Long
    Dim k               As Long
    Dim l               As Long
    Dim pX              As Long
    Dim pY              As Long
    Dim bX              As Long
    Dim bY              As Long

    Do While Game.Playing
    
        If lTmrCounter + 10 <= GetTickCount Then 'limiting fps to 10
            
            lTmrCounter = GetTickCount
            DoEvents

            For k = 1 To Balls
                If Not Ball(k).Holding Then
                    pX = Ball(k).X + Ball(k).xSpeed
                    pY = Ball(k).Y + Ball(k).ySpeed
                    
                    If pX <= 0 Then
                        pX = 0
                        Ball(k).xSpeed = -Ball(k).xSpeed
                    Else
                        If pX >= Board.W - Ball(k).D Then
                            pX = Board.W - Ball(k).D
                            Ball(k).xSpeed = -Ball(k).xSpeed
                        End If
                    End If
                    
                    If pY <= 0 Then
                        pY = 0
                        Ball(k).ySpeed = -Ball(k).ySpeed
                    Else
                        If pY >= Player.Y - Ball(k).D - Board.Y And _
                           pY < Player.Y - Board.Y + 5 Then
                            If pX >= Player.X - Ball(k).D / 2 And _
                               pX <= Player.X + Player.W + Ball(k).D / 2 Then
                               
                                pY = Player.Y - Ball(k).D - Board.Y
                                Ball(k).ySpeed = -Ball(k).ySpeed
                                
                                Call Bounce(pX, Ball(k))
                            Else
                                If pY - 8 > Board.H - (Board.Y / 2) Then
                                    Player.Lifes = Player.Lifes - 1
    
                                    Ball(k).Holding = True
                                    pX = Player.W / 2
                                    pY = Player.Y - Ball(k).D - Board.Y
                                    Ball(k).ySpeed = -3
                                End If
                            End If
                        End If
                    End If
                    
                    For l = 1 To Bricks
                        If Brick(l).Frame = 0 Then
                            bY = 1
                            If pY + Ball(k).D >= Brick(l).Y - Board.Y And _
                                pY <= Brick(l).Y + 20 - Board.Y And _
                                pX + Ball(k).D >= Brick(l).X And _
                                pX <= Brick(l).X + 50 Then
                                                               
                                If (Ball(k).Style <> BALL_RED) And _
                                    (Brick(l).Style <> BRICK_SOFT) Then
                                    If pY > Brick(l).Y Or _
                                       pY + Ball(k).D < Brick(l).Y + 20 Then
                                        Ball(k).xSpeed = -Ball(k).xSpeed
                                    Else
                                        Ball(k).ySpeed = -Ball(k).ySpeed
                                    End If
                                End If
                                           
                                If (Ball(k).Style <> BALL_BLACK) And _
                                    (Brick(l).Style <> BRICK_METAL) Then
                                   
                                    Brick(l).Frame = 1
                                    BricksLeft = BricksLeft - 1
                                            
                                    If BricksLeft - MetalBricks = 0 Then
                                        'end level
                                        Debug.Print "END LEVEL"
                                        Game.Level = Game.Level + 1
                                        'tmp:
                                        LoadLevel 1
                                    End If
                                        
                                    If Brick(l).Bonus <> BONUS_NONE Then
                                        'drop bonus
                                    End If
                                End If
                            End If
                        Else
                            If Brick(l).Frame = 6 Then
                                'RemoveItem Brick, l
                                'l = l - 1
                            End If
                            Brick(l).Frame = Brick(l).Frame + 1
                        End If
                    Next
                    
                    Ball(k).X = pX
                    Ball(k).Y = pY
                End If
            Next
            DoEvents
            DoDraw
        End If
    Loop
    
End Sub
Private Sub Bounce(bX As Long, theBall As aBALL)
Dim bW As Long
bW = theBall.D
    If bX + bW <= Player.X + 10 Then
        theBall.xSpeed = -theBall.xSpeed
    Else
        If bX + bW <= Player.X + Player.W / 5 Then
            theBall.xSpeed = 5 * IIf((theBall.xSpeed < 0), -1, 1)
        Else
            If bX + bW <= Player.X + (Player.W / 5) * 2 Then
                theBall.xSpeed = 4 * IIf((theBall.xSpeed < 0), -1, 1)
            Else
                If bX + bW <= Player.X + (Player.W / 5) * 3 Then
                    'do nothing
                    'theBall.xSpeed = theBall.xSpeed
                Else
                    If bX + bW <= Player.X + (Player.W / 5) * 3 Then
                        theBall.xSpeed = 4 * IIf((theBall.xSpeed < 0), -1, 1)
                    Else
                        If bX + bW <= Player.X + Player.W Then
                            theBall.xSpeed = 5 * IIf((theBall.xSpeed < 0), -1, 1)
                        Else
                            theBall.xSpeed = -theBall.xSpeed
                        End If
                    End If
                End If
            End If
        End If
    End If
End Sub
