Attribute VB_Name = "modGraphics"
Option Explicit

Sub BuildWindow()
    On Error GoTo errH
    
    Dim sBorder     As String
    Dim sPaddle     As String
    Dim sBall       As String
    Dim sBricks     As String
    Dim cTemp       As pcMemDC
    Dim W           As Long
    Dim H           As Long
    
    sBorder = BuildPath(App.path, "gfx\border.bmp")
    sPaddle = BuildPath(App.path, "gfx\paddle.bmp")
    sBall = BuildPath(App.path, "gfx\ball.bmp")
    sBricks = BuildPath(App.path, "gfx\bricks.bmp")
    
    If Dir(sBorder) = vbNullString Or Dir(sPaddle) = vbNullString Or _
       Dir(sBall) = vbNullString Or Dir(sBricks) = vbNullString Then
        MsgBox "Incomplete data!" & vbNewLine & "Please reinstall game.", _
                vbCritical, "Brick Ball"
        Quit
    End If
    
    Set BackBuffer = New pcMemDC
    Set PlayField = New pcMemDC
    Set Paddle = New pcMemDC
    Set cBall = New pcMemDC
    Set cBricks = New pcMemDC
    Set cTemp = New pcMemDC
    
    cTemp.CreateFromPicture LoadPicture(sBorder)
    Paddle.CreateFromPicture LoadPicture(sPaddle)
    cBall.CreateFromPicture LoadPicture(sBall)
    cBricks.CreateFromPicture LoadPicture(sBricks)
    
    With BackBuffer
        W = frmMain.picMain.ScaleWidth
        H = frmMain.picMain.ScaleHeight
        .Width = W
        .Height = H
        
        StretchBlt .hdc, 0, 0, W, H, cTemp.hdc, 9, 8, 1, 1, vbSrcCopy
        StretchBlt .hdc, 0, 0, 8, H, cTemp.hdc, 0, 9, 8, 1, vbSrcCopy
        StretchBlt .hdc, W - 8, 0, 8, H, cTemp.hdc, 0, 10, 8, 1, vbSrcCopy
        StretchBlt .hdc, 0, 0, W, 8, cTemp.hdc, 10, 0, 1, 8, vbSrcCopy
        StretchBlt .hdc, 0, 65, W, 8, cTemp.hdc, 10, 0, 1, 8, vbSrcCopy
        BitBlt .hdc, 0, 0, 9, 9, cTemp.hdc, 0, 0, vbSrcCopy
        BitBlt .hdc, W - 9, 0, 9, 9, cTemp.hdc, 0, 0, vbSrcCopy
        BitBlt .hdc, 0, 65, 9, 9, cTemp.hdc, 0, 0, vbSrcCopy
        BitBlt .hdc, W - 9, 65, 9, 9, cTemp.hdc, 0, 0, vbSrcCopy
        DoEvents
        
        Board.X = 8
        Board.Y = 73
        Board.W = W - 16
        Board.H = H - 73
        .Draw frmMain.picMain.hdc
    End With
    
    'DoDraw

    Set cTemp = Nothing
    
    Exit Sub
errH:
Debug.Print "error"
End Sub

Sub DoDraw()
'draws frame to screen
    On Error Resume Next
    DoEvents
    
    Dim cTemp   As pcMemDC
    Dim k       As Long
    Dim pX      As Long
    Dim pY      As Long
    
    Set cTemp = New pcMemDC
    
    pX = Player.X + Board.X
    
    With cTemp
        .Width = BackBuffer.Width
        .Height = BackBuffer.Height
        
        BackBuffer.Draw .hdc 'draws background
        
        'draws paddle
        StretchBlt .hdc, pX, Player.Y, Player.W, 12, _
                    Paddle.hdc, 0, 0, 2, 12, vbSrcCopy
        For k = 1 To Player.bCount 'see if we need to draw guns...
            If Player.Style(k) = BONUS_NONE Then
                'draw normal edges
                BitBlt .hdc, pX, Player.Y, 6, 12, Paddle.hdc, 10, 0, vbSrcCopy
                BitBlt .hdc, pX + Player.W - 6, Player.Y, 6, 12, _
                       Paddle.hdc, 3, 0, vbSrcCopy
            Else
                If Player.Style(k) = BONUS_GUN Then
                    'draw gun (level 1) edges
                    BitBlt .hdc, pX, Player.Y - 7, 12, 19, _
                            Paddle.hdc, 13, 13, vbSrcCopy
                    BitBlt .hdc, pX + Player.W - 12, Player.Y - 7, 12, 19, _
                            Paddle.hdc, 0, 13, vbSrcCopy
                Else
                    If Player.Style(k) = BONUS_SUPERGUN Then
                        'draw gun (level 2) edges
                        BitBlt .hdc, pX, Player.Y - 8, 13, 20, _
                                Paddle.hdc, 14, 33, vbSrcCopy
                        BitBlt .hdc, pX + Player.W - 13, Player.Y - 8, 13, 20, _
                                Paddle.hdc, 0, 33, vbSrcCopy
                    Else
                    End If
                End If
            End If
        Next
        
        'draw bricks
        For k = 1 To Bricks
            pX = Brick(k).Style
            pY = Brick(k).Frame * 20
            BitBlt .hdc, Brick(k).X, Brick(k).Y, 50, 20, cBricks.hdc, pX, pY, vbSrcCopy
        Next
        
        'draw ball(s)
        For k = 1 To Balls
            
            If Ball(k).Holding = True Then
                pX = Player.X + Ball(k).X
            Else
                pX = Board.X + Ball(k).X
            End If
            
            pY = Board.Y + Ball(k).Y
            
            If Ball(k).Style = BALL_NORMAL Then
                BitBlt .hdc, pX, pY, 15, 15, cBall.hdc, 0, 0, vbSrcCopy
            Else
            End If
        Next
        
        .Draw frmMain.picMain.hdc
    End With
    
    Set cTemp = Nothing
End Sub
